# Coveo ResultFolding Component (CoveoResultFolding)

The `ResultFolding` component renders folded result sets. It is usable inside a result template when there is an active `Folding` component in the page. This component takes care of rendering the parent result and its child results in a coherent manner.

This component is a result template component (see Result Templates).

See Folding Results.

## Index

### Methods

- debugInfo
- disable
- enable
- getBindings
- showLessResults
- showMoreResults
- get

### Properties

- bind
- componentOptionsModel
- componentStateModel
- disabled
- logger
- queryController
- queryStateModel
- root
- searchInterface
- ID

### Accessors

- usageAnalytics

### Component Options

- expandedCaption
- lessCaption
- moreCaption
- normalCaption
- oneResultCaption
- resultTemplate

### Constructors

- constructor

## Methods

### debugInfo

- debugInfo(): any

- Inherited from BaseComponent.debugInfo

  - Defined in ui/Base/BaseComponent.ts :41

  Return the debug info about this component.

  #### Returns any

### disable

- disable(): void

- Inherited from BaseComponent.disable

  - Defined in ui/Base/BaseComponent.ts :52

  Disable the component. Normally this means that the component will not execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### enable

- enable(): void

- Inherited from BaseComponent.enable

  - Defined in ui/Base/BaseComponent.ts :61

  Enable the component. Normally this means that the component will execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### getBindings

- getBindings(): IComponentBindings

- Inherited from Component.getBindings

  - Defined in ui/Base/Component.ts :328

  Return the bindings, or environment, for the current component.

  #### Returns IComponentBindings

### showLessResults

- showLessResults(): Promise<void>

- - Defined in ui/ResultFolding/ResultFolding.ts :196

  Show less results for a given conversation. This is the equivalent of clicking "Show less"

  #### Returns Promise<void>

### showMoreResults

- showMoreResults(): Promise<IQueryResult[]>

- - Defined in ui/ResultFolding/ResultFolding.ts :159

  Show more results by fetching additional results from the index, which match the current folded conversation. This is the equivalent of clicking "Show all conversation".

  #### Returns Promise<IQueryResult[]>

### Static get

- get(element: HTMLElement, componentClass?: any, noThrow?: boolean): BaseComponent

- Inherited from Component.get

  - Defined in ui/Base/Component.ts :410

  Get the bound component to the given HTMLElement. Throws an assert if the HTMLElement has no component bound, unless using the noThrow argument.
  If there is multiple component bound to the current HTMLElement, you must specify the component class.

  #### Parameters

  - ##### element: HTMLElement

    HTMLElement for which to get the bound component.

  - ##### Optional componentClass: any

    Optional component class. If the HTMLElement has multiple components bound, you must specify which one you are targeting.

  - ##### Optional noThrow: boolean

    Boolean option to tell the method to not throw on error.

  #### Returns BaseComponent

## Properties

### bind

bind: ComponentEvents

Inherited from Component.bind

- Defined in ui/Base/Component.ts :270

Allows the component to bind events and execute them only when it is enabled.

type

  {Coveo.ComponentEvents}

### componentOptionsModel

componentOptionsModel: ComponentOptionsModel

Inherited from Component.componentOptionsModel

- Defined in ui/Base/Component.ts :294

Contains the state of options for different components. Mainly used by ResultLink.

### componentStateModel

componentStateModel: ComponentStateModel

Inherited from Component.componentStateModel

- Defined in ui/Base/Component.ts :282

Contains the state of different components (enabled vs disabled). Allows to get/set values. Triggers component state event when modified. Each component can listen to those events.

### disabled

disabled: boolean

Inherited from BaseComponent.disabled

- Defined in ui/Base/BaseComponent.ts :23

A disabled component will not participate in the query, or listen to ComponentEvents.

type

  {boolean}

### logger

logger: Logger

Inherited from BaseComponent.logger

- Defined in ui/Base/BaseComponent.ts :18

Allows component to log in the dev console.

### queryController

queryController: QueryController

Inherited from Component.queryController

- Defined in ui/Base/Component.ts :286

Contains the singleton that allows to trigger queries.

### queryStateModel

queryStateModel: QueryStateModel

Inherited from Component.queryStateModel

- Defined in ui/Base/Component.ts :278

Contains the state of the query. Allows to get/set values. Trigger query state event when modified. Each component can listen to those events.

### root

root: HTMLElement

Inherited from Component.root

- Defined in ui/Base/Component.ts :274

A reference to the root HTMLElement (the SearchInterface).

### searchInterface

searchInterface: SearchInterface

Inherited from Component.searchInterface

- Defined in ui/Base/Component.ts :290

A reference to the root of every component, the SearchInterface.

### Static ID

ID: string

Inherited from BaseComponent.ID

- Defined in ui/Base/BaseComponent.ts :28

The static ID that each component needs in order to be identified.
For example, SearchButton -> static ID: SearchButton -> className: CoveoSearchButton

## Accessors

### usageAnalytics

- get (): IAnalyticsClient

- Inherited from Component.usageAnalytics

  - Defined in ui/Base/Component.ts :343

  A reference to the Analytics.client.

  #### Returns IAnalyticsClient

## Component Options

### expandedCaption

expandedCaption: string

- Defined in ui/ResultFolding/ResultFolding.ts :93

Specifies the caption to display at the top of the child results when the folding result set is expanded.

Default value is `undefined`, which displays no caption.

Markup configuration example(s) :

    data-expanded-caption='foo'

### lessCaption

lessCaption: string

- Defined in ui/ResultFolding/ResultFolding.ts :107

Specifies the caption to display on the link to shrink the loaded folding result set back to only the top result.

Default value is the localized string for `ShowLess`.

Markup configuration example(s) :

    data-less-caption='foo'

### moreCaption

moreCaption: string

- Defined in ui/ResultFolding/ResultFolding.ts :100

Specifies the caption to display on the link to expand / show child results.

Default value is the localized string for `ShowMore`.

Markup configuration example(s) :

    data-more-caption='foo'

### normalCaption

normalCaption: string

- Defined in ui/ResultFolding/ResultFolding.ts :86

Specifies the caption to display at the top of the child results when the folding result set is not expanded.

Default value is `undefined`, which displays no caption.

Markup configuration example(s) :

    data-normal-caption='foo'

### oneResultCaption

oneResultCaption: string

- Defined in ui/ResultFolding/ResultFolding.ts :114

Specifies the caption to display when there is only one result in a folding result set.

Default value is the localized string for `DisplayingTheOnlyMessage`

Markup configuration example(s) :

    data-one-result-caption='foo'

### resultTemplate

resultTemplate: Template

- Defined in ui/ResultFolding/ResultFolding.ts :79

Specifies the template to use to render each of the child results for a top result.

You can specify a previously registered template to use either by referring to its HTML `id` attribute or to a CSS selector (see TemplateCache).

Example:

Specifying a previously registered template by referring to its HTML `id` attribute:

    <span class="CoveoResultFolding" data-result-template-id="Foo"></span>

Specifying a previously registered template by referring to a CSS selector:

    <span class='CoveoResultFolding' data-result-template-selector="#Foo"></span>

If you do not specify a custom folding template, the component uses the default result folding template.

## Constructors

### constructor

- new ResultFolding(element: HTMLElement, options?: IResultFoldingOptions, bindings?: IComponentBindings, result?: IQueryResult): ResultFolding

- Overwrites Component.constructor

  - Defined in ui/ResultFolding/ResultFolding.ts :129

  Creates a new ResultFolding component.

  #### Parameters

  - ##### element: HTMLElement

  - ##### Optional options: IResultFoldingOptions

    The options for the ResultFolding component.

  - ##### Optional bindings: IComponentBindings

    The bindings that the component requires to function normally. If not set, these will be automatically resolved (with a slower execution time).

  - ##### Optional result: IQueryResult

    The result to associate the component with.

  #### Returns ResultFolding